Package: calms
Type: Package
Title: Comprehensive Analysis of Latent Means
Version: 1.0-3
Encoding: UTF-8
Date: 2026-04-06
Author: Kim Nimon [aut, cre],
  Julia Fulmore [aut]
Authors@R: c(person(given = "Kim", family = "Nimon", role = c("aut", "cre"), email = "kim.nimon@gmail.com"), person(given="Julia", family="Fulmore",role="aut"))
Maintainer: Kim Nimon <kim.nimon@gmail.com>
Depends: R (>= 3.5)
Imports:
        dplyr,DT,foreign,lavaan,lsr,MatchIt,shiny,shinyjs,stringr,bslib
Description: Provides a Shiny application to conduct comprehensive analysis of latent means including the examination of group equivalency, propensity score analysis, 
 measurement invariance analysis, and assessment of latent mean differences of 
 equivalent groups with invariant data. Group equivalency and propensity score analyses are implemented using the 'MatchIt' package [Ho et al. (2011) <doi:10.18637/jss.v042.i08>], 
 ensuring robust control for covariates. Structural equation modeling and invariance testing rely heavily on the 'lavaan' package [Rosseel (2012) <doi:10.18637/jss.v048.i02>], 
 providing a flexible and powerful modeling framework. The application also integrates modified functions from Hammack-Brown et al. (2021) <doi:10.1002/hrdq.21452> 
 to support factor ratio testing and the list-and-delete procedure. 
Suggests: knitr,rmarkdown,rgenoud,Matching
License: GPL (>= 2)
RoxygenNote: 7.3.2
VignetteBuilder: knitr
LazyData: true
NeedsCompilation: no
Packaged: 2026-04-06 14:46:47 UTC; kimnimon
Repository: CRAN
Date/Publication: 2026-04-06 15:50:02 UTC
Built: R 4.6.0; ; 2026-04-29 13:15:51 UTC; unix

## ----setup, include = FALSE---------------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "",
  eval = TRUE
)

## ----eval = FALSE-------------------------------------------------------------
#  install.packages("calms",dependencies=TRUE)

## ----eval = FALSE-------------------------------------------------------------
#  calms::run_calms()

## ----eval = FALSE-------------------------------------------------------------
#  ###Load necessary packages
#  library(foreign)
#  library(haven)
#  
#  ### Read in data set without labels
#  dso <-
#    read.spss("ZA6770_v2-1-0.sav",
#    use.value.labels=FALSE, max.value.labels=Inf, to.data.frame=TRUE)
#  nrow(dso)
#  names(dso)
#  
#  ### Read in data set with labels
#  dsoa <-
#    read.spss("ZA6770_v2-1-0.sav",
#    use.value.labels=TRUE, max.value.labels=Inf, to.data.frame=TRUE)
#  nrow(dsoa)
#  names(dsoa)
#  
#  ### Select only needed columns
#  #quality of job content (JC: v22-v24) and quality of work environment (WE: v25-v27)
#  #demographics:SEX,EMPREL,TYPORG2,DEGREE
#  ds<-subset(dso,select=c(country,v22:v27,SEX,DEGREE,EMPREL,TYPORG2))
#  names(ds)
#  
#  ds[,c("country","SEX","DEGREE","EMPREL","TYPORG2")]<-dsoa[,c("country","SEX","DEGREE","EMPREL","TYPORG2")]
#  
#  ###Get data for the groups (i.e., countries)
#  #country numerical codes in SPSS: UK = 826, US = 840
#  table(ds$country)
#  ds<-subset(ds,(country=="GB-Great Britain and/or United Kingdom" | country=="US-United States"))
#  ds$country<-factor(ds$country)
#  table(ds$country)
#  nrow(ds)
#  
#  ###getting rid of missing values
#  nrow(ds)
#  ds<-na.omit(ds)
#  nrow(ds)
#  
#  ###check values
#  table(ds$SEX)
#  table(ds$DEGREE)
#  table(ds$EMPREL)
#  table(ds$TYPORG2)
#  table(ds$country)
#  
#  levels(ds$EMPREL)<-c("Employee","Self-employed","Self-employed",NA)
#  levels (ds$DEGREE)<-c(rep("no univ",5),rep("univ",2))
#  
#  ###getting rid of missing values
#  nrow(ds)
#  ds<-na.omit(ds)
#  nrow(ds)
#  
#  ds$SEX
#  levels(ds$SEX)
#  levels(ds$SEX)<-c(1,0)     #Set "Male" to 1
#  
#  levels(ds$EMPREL)
#  levels(ds$EMPREL)<-c(0,1)  #Set "Employee" to 1
#  
#  levels(ds$TYPORG2)
#  levels(ds$TYPORG2)<-c(0,1) #Set "Private employer" to 1
#  
#  levels(ds$DEGREE)
#  levels(ds$DEGREE)<-c(0,1)  #Set "univ" to 1
#  
#  levels(ds$country)
#  levels(ds$country)<-c(1,0) #Set "US-United States" to 1
#  
#  ds$SEX<-as.numeric(ds$SEX)-1
#  ds$EMPREL<-as.numeric(ds$EMPREL)-1
#  ds$TYPORG2<-as.numeric(ds$TYPORG2)-1
#  ds$DEGREE<-as.numeric(ds$DEGREE)-1
#  ds$country<-as.numeric(ds$country)-1
#  
#  nrow(ds)
#  names(ds)
#  
#  write_sav(ds,"WosDemo.sav")

## ----results="markup",echo=FALSE----------------------------------------------
library(calms)
data("WosDemoMeta")
WosDemoMeta

server = function(input, output,session) {

output$frame<-renderUI({
  test<-"https://player.vimeo.com/video/1102286467?h=045f02e910&amp;title=0&amp;byline=0&amp;portrait=0&amp;badge=0&amp;autopause=0&amp;player_id=0&amp;app_id=58479"
  my_test<-tags$iframe(src=test,height=600,width=535)
  my_test<-tags$iframe(src=test,style="height:600px;width:100%",allowfullscreen=TRUE)
  my_test
})

output$output<-NULL

shinyjs::disable("analyze")
shinyjs::disable("datbut")
shinyjs::disable("chkbut")
shinyjs::disable("psabut")
shinyjs::disable("datbut2")
shinyjs::disable("mibut")
shinyjs::disable("mimodbut")
shinyjs::disable("metricbut")
shinyjs::disable("metricmodbut")
shinyjs::disable("scalarbut")
shinyjs::disable("scalarmodbut")
shinyjs::disable("latentbut")
shinyjs::disable("latentbut2")
shinyjs::disable("latentmodbut")

observeEvent(input$ccall,{
  if (is.character(input$ccall)==TRUE){
    formc<-sub("data=dspsm.*","",input$ccall)
    formm<-sub("data=dspsm.*","",mcall)
    if (formc!= formm){
      shinyjs::disable("analyze")
      showNotification("Call to matchit must have the same formula and data arguments as the default",type="error")
    }else{
      if (str_sub(input$ccall,-1,-1)==")"){
        shinyjs::enable("analyze")
      }else{
        shinyjs::disable("analyze")
        showNotification("Call to matchit missing ')'",type="error")
      }
    }
  }else{
    shinyjs::disable("analyze")
  }

})

observeEvent(input$psaarg,{
    hideTab(inputId="tabSelected",target="psa")
    if (input$anal=="psa") updateTabsetPanel(session,"tabSelected","psasetup")
    if (input$psaarg==TRUE){
     output$call<-NULL
     output$ccall<-NULL
    }else{
      output$ccall<-renderUI({
        textAreaInput("ccall","Edit code after 'data=dspsm' to customize arguments to matchit",value=mcall,width='120%')
        }) 
    }
})

observeEvent(input$usewos,{
      hideTab(inputId="tabSelected",target="check")
      hideTab(inputId="tabSelected",target="psa")
      hideTab(inputId="tabSelected",target="mi")
      hideTab(inputId="tabSelected",target="metric")
      hideTab(inputId="tabSelected",target="scalar")
      hideTab(inputId="tabSelected",target="latent")
      hideTab(inputId="tabSelected",target="psasetup")
      if (input$usewos==TRUE){
        datau<<-read.spss("WosDemo.sav",use.value.labels=TRUE, max.value.labels=Inf, to.data.frame=TRUE)
        metad<<-as.data.frame(read.csv("WosDemoMeta.csv"))
        colnames(datau)<<-metad$item
        slevels<-table(subset(metad,type=="item")$scale)
        scales<-names(slevels)
        scales<<-scales
        group<-metad$item[metad$type=="group"]
        cov<-metad$item[metad$type=="cov"]
        items<-metad$item[(metad$type=="item")]
        datau<<-datau[,stringr::str_sort(colnames(datau),numeric=TRUE)]
        datal<-select_if(datau,is.numeric)
        datal<-datal[,grepl("[0-9]",colnames(datal))]
        updateSelectInput(session,"usepsa",choices=FALSE)
        updateSelectInput(session,"checkvars",choices=cov,selected=cov)
        updateSelectInput(session,"psavars",choices=cov,selected=cov)
        updateSelectInput(session,"items",choices=items,selected=items)
        updateSelectInput(session, "group",choices = group,selected=group)
        updateSelectInput(session,"scales",choices=scales)
        updateSelectInput(session,"means",choices=scales)
        updateSelectInput(session,"anal",choices = c("Check Group Equivalency"='check',"Propensity Score Analysis"='psa',
                                                  "Measurement Invariance"='mi',
                                                  "Metric Invariance"='metric',
                                                  "Scalar Invariance"='scalar',"Structural Invariance"='latent'))
        shinyjs::enable("analyze")
        output$metatab<-renderDT(metad,caption="Meta Data",rownames=FALSE,options=list(pageLength=5,lengthChange=FALSE,searching=FALSE))
        output$datatab<-renderDT(datau,caption="Cleaned Data",rownames=TRUE,options=list(pageLength=5,lengthChange=FALSE,searching=FALSE,scrollX=TRUE))
#        updateTabsetPanel(session,"tabSelected","data")
        output$metbut <- downloadHandler(
            filename = function() {
            "meta.csv"
        },
        content = function(file) {
            write.csv(metad,file,row.names=FALSE)
        }
        )
        shinyjs::enable("metbut")
      } else {
          datau<<-NULL
          metad<<-NULL
          shinyjs::disable("analyze")
          updateSelectInput(session,"usepsa",choices=FALSE)
          updateSelectInput(session,"anal",choices=c("None"))
      }
})

  observeEvent(input$upload,{
#    cleanup(output)
    shinyjs::disable("metbut")
    shinyjs::disable("datbut")
    error<-TRUE
    if (length(input$upload$name)!=2){
      showNotification("Only two files should be uploaded.",type="error")
    } else {
      metaf<-NULL
      dataf<-1  
      for (i in 1:2){
        if (str_sub(input$upload$name[i],-8,-1)=="Meta.csv"){
          metaf<-i
        }
      }
      if (is.null(metaf)){
        showNotification("*Meta.csv not uploaded.",type="error")
      } else {
        if (metaf==1) dataf<-2
        metad<-read.csv(input$upload$datapath[metaf])
        if (sum(colnames(metad)==c("itemo","item","type","scale","ds","missing"))!=6){
          showNotification("*Meta.csv not correctly formatted.",type="error")
        } else if (metad[1,"ds"]!=input$upload$name[dataf]){
          showNotification("Dataset identified in metadata not uploaded.",type="error")
        }else{
          ext<-str_sub(input$upload$name[dataf],-4,-1)
          if (ext==".dat"){
            datau<-read.table(input$upload$datapath[dataf],sep="\t")
            error<-FALSE
          } else if (ext == ".csv"){
            datau<-read.csv(input$upload$datapath[dataf])
            error<-FALSE
          } else if (ext == ".sav") {
            datau<-read.spss(input$upload$datapath[dataf])
            error<-FALSE
          } else {
            showNotification("Unsupported file type detected. Please upload a .CSV, .DAT, or .SAV file.",type="error")
          }
        }
      }
    }
    if (error==FALSE){
      datau<-as.data.frame(datau)
      metado<-as.data.frame(metad)
      metad<-subset(metado,((type=="item") | (type=="cov")| (type=="group")))
      if (nrow(metado)!= nrow(metad)){
        showNotification("type must be item, cov, or group",type="error")
        error<-TRUE
      }else if ((length(unique(metad$itemo))!=nrow(metad)) | (length(unique(metad$item))!=nrow(metad))){
        showNotification("Not all item names in meta file are unique.",type="error")
        error<-TRUE
      } else {
        check<-na.omit(match(metad$itemo,colnames(datau)))
        if (length(check)!=nrow(metad)){
          showNotification("Not all variables in meta file contained in data file.", type="error")
          error<-TRUE
        }
      }
    }
    if (error==FALSE){
        slevels<-table(subset(metad,type=="item")$scale)
        if (length(slevels)<1){
           showNotification("At least one scale needs to be identified",type="error")   
        } else if ((length(slevels)==1)& (min(slevels)<3)){
           showNotification("At least one scale with three items need to be identified",type="error")     
        } else if ((length(slevels)>1) & (min(slevels)<2)){
           showNotification("At least two scales with two items each need to be identified",type="error")          
        }else{ 
          metad<<-metad
          scales<<-names(slevels)
          colnames(datau)[check]<-metad$item
          datau<-datau[,metad$item]
          datau<-select_if(datau,is.numeric)
          if (is.numeric(metad[1,"missing"])) datau<-datau %>% replace_with_na_all(condition= ~.x == metad[1,"missing"])
          datau<-as.data.frame(datau)
          datau<-na.omit(datau)
          datau<-datau[,stringr::str_sort(colnames(datau),numeric=TRUE)]
          head(datau)
          datau<<-datau
          psads<<-datau
          group<-metad$item[metad$type=="group"]
          cov<-metad$item[metad$type=="cov"]
          items<-metad$item[(metad$type=="item")]
          updateCheckboxInput(session,"usewos",value=FALSE)
          updateSelectInput(session,"usepsa",choices=FALSE)
          updateSelectInput(session,"checkvars",choices=cov,selected=cov)
          updateSelectInput(session,"psavars",choices=cov,selected=cov)
          updateSelectInput(session,"items",choices=items,selected=items)
          updateSelectInput(session, "group",choices = group,selected=group)
          updateSelectInput(session,"scales",choices=scales)
          updateSelectInput(session,"means",choices=scales)
          updateSelectInput(session,"anal",choices = c("Check Group Equivalency"='check',"Propensity Score Analysis"='psa',
                                                  "Measurement Invariance"='mi',
                                                  "Metric Invariance"='metric',
                                                  "Scalar Invariance"='scalar',"Structural Invariance"='latent'))
          output$metatab<-renderDT(metad,caption="Meta Data",rownames=FALSE,options=list(pageLength=5,lengthChange=FALSE,searching=FALSE))
          output$datatab<-renderDT(datau,caption="Cleaned Data",rownames=TRUE,options=list(pageLength=5,lengthChange=FALSE,searching=FALSE,scrollX=TRUE))
          updateTabsetPanel(session,"tabSelected","data")
          output$metbut <- downloadHandler(
            filename = function() {
            "meta.csv"
          },
          content = function(file) {
            write.csv(metad,file,row.names=FALSE)
          }
          )
          output$datbut <- downloadHandler(
            filename = function() {
            "clean_data.csv"
          },
          content = function(file) {
            write.csv(datau,file,row.names=TRUE)
          }
          )
          shinyjs::enable("metbut")
          shinyjs::enable("datbut")
#          shinyjs::enable("analyze")
        }
#      }
    }
  }) #observeEvent

observeEvent(input$psavars,{

        if ((input$anal=="psa")&(input$group!="") & (input$group!="None") & (length(input$psavars)>0)){
          if (length(table(datau[,input$group]))==2){
            showTab(inputId="tabSelected",target="psasetup")
            updateTabsetPanel(session,"tabSelected","psasetup")
            ds2<-datau %>% dplyr::select(!!!input$psavars)
            covs<-covs2<-colnames(ds2)
            if (length(input$checkvars)>0){
              ds2<-datau %>% dplyr::select(!!!input$checkvars)
              covs2<-colnames(ds2)
            }
            mcall<<-psacall(input,cov,covs)
            output$mcall <- renderUI({
              HTML(paste("Default call to matchit:", "<br><br>", mcall, "<br>"))
            })
            if (input$psaarg==FALSE){
              output$ccall<-renderUI({
                textAreaInput("ccall","Edit code after 'data=dspsm' to customize arguments to matchit",value=mcall,width='100%')
              })
            } 
            hideTab(inputId="tabSelected",target="psa")
            shinyjs::enable("analyze")
          } else {
            showNotification("Group must have two levels",type="error")
            shinyjs::disable("analyze")
          }
        }
})

observeEvent(input$anal,{

        if ((input$anal=="check") & (input$group!="") & (input$group!="None") & (length(input$checkvars)>0)){
          if (length(table(datau[,input$group]))==2){
            shinyjs::enable("analyze")
          } else {
            showNotification("Group must have two levels",type="error")
            shinyjs::disable("analyze")
          }
        } else if ((input$anal=="psa")&(input$group!="") & (input$group!="None") & (length(input$psavars)>0)){
          if (length(table(datau[,input$group]))==2){
            showTab(inputId="tabSelected",target="psasetup")
            updateTabsetPanel(session,"tabSelected","psasetup")
            ds2<-datau %>% dplyr::select(!!!input$psavars)
            covs<-covs2<-colnames(ds2)
            if (length(input$checkvars)>0){
              ds2<-datau %>% dplyr::select(!!!input$checkvars)
              covs2<-colnames(ds2)
            }
            mcall<<-psacall(input,cov,covs)
#            output$mcall<-renderUI({HTML(paste("Default call to matchit:","<br>","<br>",mcall,"<br>"))})
            output$mcall <- renderUI({
              HTML(paste(
                'Default call to <a href="https://rdrr.io/cran/MatchIt/man/matchit.html" target="_blank">matchit</a>:',
                "<br><br>",
                mcall
              ))
            })
            if (input$psaarg==FALSE){
              output$ccall<-renderUI({
                textAreaInput("ccall","Edit code after 'data=dspsm' to customize arguments to matchit",value=mcall,width='100%')
              })
            } 
            hideTab(inputId="tabSelected",target="psa")
            shinyjs::enable("analyze")
          } else {
            showNotification("Group must have two levels",type="error")
            shinyjs::disable("analyze")
          }
        } else if (((input$anal=="mi")| (input$anal=="latent"))&(input$group!="") & (input$group!="None") & (length(input$items)>0)){
          shinyjs::enable("analyze")
        } else if ((input$anal=="metric")&(input$group!="") & (input$group!="None") & (input$scales!="None")){
          shinyjs::enable("analyze")
        } else if ((input$anal=="scalar")&(input$group!="") & (input$group!="None") & (input$scales!="None")){
          shinyjs::enable("analyze")
        } else {
          shinyjs::disable("analyze")
        }
  
})

observeEvent(input$loadings,{

        if ((input$anal=="check") & (input$group!="") & (input$group!="None") & (length(input$checkvars)>0)){
          if (length(table(datau[,input$group]))==2){
            shinyjs::enable("analyze")
          } else {
            showNotification("Group must have two levels",type="error")
            shinyjs::disable("analyze")
          }
        } else if ((input$anal=="psa")&(input$group!="") & (input$group!="None") & (length(input$psavars)>0)){
          if (length(table(datau[,input$group]))==2){
            shinyjs::enable("analyze")
          } else {
            showNotification("Group must have two levels",type="error")
            shinyjs::disable("analyze")
          }
        } else if (((input$anal=="mi")| (input$anal=="latent"))&(input$group!="") & (input$group!="None") & (length(input$items)>0)){
          shinyjs::enable("analyze")
        } else if ((input$anal=="metric")&(input$group!="") & (input$group!="None") & (input$scales!="None")){
          shinyjs::enable("analyze")
        } else if ((input$anal=="scalar")&(input$group!="") & (input$group!="None") & (input$scales!="None")){
          shinyjs::enable("analyze")
        } else {
          shinyjs::disable("analyze")
        }
  
})

observeEvent(input$intercepts,{

        if ((input$anal=="check") & (input$group!="") & (input$group!="None") & (length(input$checkvars)>0)){
          if (length(table(datau[,input$group]))==2){
            shinyjs::enable("analyze")
          } else {
            showNotification("Group must have two levels",type="error")
            shinyjs::disable("analyze")
          }
        } else if ((input$anal=="psa")&(input$group!="") & (input$group!="None") & (length(input$psavars)>0)){
          if (length(table(datau[,input$group]))==2){
            shinyjs::enable("analyze")
          } else {
            showNotification("Group must have two levels",type="error")
            shinyjs::disable("analyze")
          }
        } else if (((input$anal=="mi")| (input$anal=="latent"))&(input$group!="") & (input$group!="None") & (length(input$items)>0)){
          shinyjs::enable("analyze")
        } else if ((input$anal=="metric")&(input$group!="") & (input$group!="None") & (input$scales!="None")){
          shinyjs::enable("analyze")
        } else if ((input$anal=="scalar")&(input$group!="") & (input$group!="None") & (input$scales!="None")){
          shinyjs::enable("analyze")
        } else {
          shinyjs::disable("analyze")
        }
  
})


observeEvent(input$group,{

        if ((input$anal=="check") & (input$group!="") & (input$group!="None") & (length(input$checkvars)>0)){
          if (length(table(datau[,input$group]))==2){
            shinyjs::enable("analyze")
          } else {
            showNotification("Group must have two levels",type="error")
            shinyjs::disable("analyze")
          }
        } else if ((input$anal=="psa")&(input$group!="") & (input$group!="None") & (length(input$psavars)>0)){
          if (length(table(datau[,input$group]))==2){
            shinyjs::enable("analyze")
          } else {
            showNotification("Group must have two levels",type="error")
            shinyjs::disable("analyze")
          }
        } else if (((input$anal=="mi")| (input$anal=="latent"))&(input$group!="") & (input$group!="None") & (length(input$items)>0)){
          shinyjs::enable("analyze")
        } else if ((input$anal=="metric")&(input$group!="") & (input$group!="None") & (input$scales!="None")){
          shinyjs::enable("analyze")
        } else if ((input$anal=="scalar")&(input$group!="") & (input$group!="None") & (input$scales!="None")){
          shinyjs::enable("analyze")
        } else {
          shinyjs::disable("analyze")
        }
  
})

observeEvent(input$checkvars,{

        if ((input$anal=="check") & (input$group!="") & (input$group!="None") & (length(input$checkvars)>0)){
          if (length(table(datau[,input$group]))==2){
            shinyjs::enable("analyze")
          } else {
            showNotification("Group must have two levels",type="error")
            shinyjs::disable("analyze")
          }
        } else if ((input$anal=="psa")&(input$group!="") & (input$group!="None") & (length(input$psavars)>0)){
          if (length(table(datau[,input$group]))==2){
            shinyjs::enable("analyze")
          } else {
            showNotification("Group must have two levels",type="error")
            shinyjs::disable("analyze")
          }
        } else if (((input$anal=="mi")| (input$anal=="latent"))&(input$group!="") & (input$group!="None") & (length(input$items)>0)){
          shinyjs::enable("analyze")
        } else if ((input$anal=="metric")&(input$group!="") & (input$group!="None") & (input$scales!="None")){
          shinyjs::enable("analyze")
        } else if ((input$anal=="scalar")&(input$group!="") & (input$group!="None") & (input$scales!="None")){
          shinyjs::enable("analyze")
        } else {
          shinyjs::disable("analyze")
        }
  
})

observeEvent(input$items,{
    error<-TRUE
    if ((!is.null(input$items))&&(length(input$items) >0) ){
      scaletab<-table(na.omit(metad$scale[match(input$items,metad$item)]))
      if (min(scaletab)>1){
        error<-FALSE
        scales<<-names(scaletab)
        updateSelectInput(session,"loadings",choices=input$items)
        updateSelectInput(session,"intercepts",choices=input$items)
        updateSelectInput(session,"scales",choices=scales)
        updateSelectInput(session,"means",choices=scales)
      } 
    }
    if (error==TRUE){
      showNotification("Each scale must have at least three items.",type="error")
    }else{
        if ((input$anal=="check") & (input$group!="") & (input$group!="None") & (length(input$checkvars)>0)){
          if (length(table(datau[,input$group]))==2){
            shinyjs::enable("analyze")
          } else {
            showNotification("Group must have two levels",type="error")
            shinyjs::disable("analyze")
          }
        } else if ((input$anal=="psa")&(input$group!="") & (input$group!="None") & (length(input$psavars)>0)){
          if (length(table(datau[,input$group]))==2){
            shinyjs::enable("analyze")
          } else {
            showNotification("Group must have two levels",type="error")
            shinyjs::disable("analyze")
          }
        } else if (((input$anal=="mi")| (input$anal=="latent"))&(input$group!="") & (input$group!="None") & (length(input$items)>0)){
          shinyjs::enable("analyze")
        } else if ((input$anal=="metric")&(input$group!="") & (input$group!="None") & (input$scales!="None")){
          shinyjs::enable("analyze")
        } else if ((input$anal=="scalar")&(input$group!="") & (input$group!="None") & (input$scales!="None")){
          shinyjs::enable("analyze")
        } else {
          shinyjs::disable("analyze")
        }
     }
})

observeEvent(input$psavars,{

        if ((input$anal=="check") & (input$group!="") & (input$group!="None") & (length(input$checkvars)>0)){
          if (length(table(datau[,input$group]))==2){
            shinyjs::enable("analyze")
          } else {
            showNotification("Group must have two levels",type="error")
            shinyjs::disable("analyze")
          }
        } else if ((input$anal=="psa")&(input$group!="") & (input$group!="None") & (length(input$psavars)>0)){
          if (length(table(datau[,input$group]))==2){
            shinyjs::enable("analyze")
          } else {
            showNotification("Group must have two levels",type="error")
            shinyjs::disable("analyze")
          }
        } else if (((input$anal=="mi")| (input$anal=="latent"))&(input$group!="") & (input$group!="None") & (length(input$items)>0)){
          shinyjs::enable("analyze")
        } else if ((input$anal=="metric")&(input$group!="") & (input$group!="None") & (input$scales!="None")){
          shinyjs::enable("analyze")
        } else if ((input$anal=="scalar")&(input$group!="") & (input$group!="None") & (input$scales!="None")){
          shinyjs::enable("analyze")
        } else {
          shinyjs::disable("analyze")
        }
  
})



observeEvent(input$scales,{

        if ((input$anal=="check") & (input$group!="") & (input$group!="None") & (length(input$checkvars)>0)){
          if (length(table(datau[,input$group]))==2){
            shinyjs::enable("analyze")
          } else {
            showNotification("Group must have two levels",type="error")
            shinyjs::disable("analyze")
          }
        } else if ((input$anal=="psa")&(input$group!="") & (input$group!="None") & (length(input$psavars)>0)){
          if (length(table(datau[,input$group]))==2){
            shinyjs::enable("analyze")
          } else {
            showNotification("Group must have two levels",type="error")
            shinyjs::disable("analyze")
          }
        } else if (((input$anal=="mi")| (input$anal=="latent"))&(input$group!="") & (input$group!="None") & (length(input$items)>0)){
          shinyjs::enable("analyze")
        } else if ((input$anal=="metric")&(input$group!="") & (input$group!="None") & (input$scales!="None")){
          shinyjs::enable("analyze")
        } else if ((input$anal=="scalar")&(input$group!="") & (input$group!="None") & (input$scales!="None")){
          shinyjs::enable("analyze")
        } else {
          shinyjs::disable("analyze")
        }
  
})


observeEvent(input$analyze,{

  if((input$anal=="check")&(!is.null(input$checkvars))){
    shinyjs::disable("analyze")
    shinyjs::disable("chkbut")
    showTab(inputId="tabSelected",target="check")
    updateTabsetPanel(session,"tabSelected","check")
    ds2<-datau %>% dplyr::select(!!!input$checkvars)
    covs<-colnames(ds2)
    chkout<-psacheck(input$group,covs,input$seed)
    chktab<-chkout[[1]]
    chktabo<-chktab
    chktabo$x<-""
    output$chktab<-renderDT({
      colnames(chktabo)[5]<-" "
      datatable(chktabo,rownames=TRUE,options=list(pageLength=5,columnDefs=list(list(targets=5,width='300px'),
                                                                   list(targets=0,width='100px'),
                                                                   list(targets=c(1:4),width='70px')))) %>%  
#              formatStyle(0,target="row",backgroundColor=styleRow(seq(1,nrow(chktabo),2),"lightgrey")) %>%
              formatRound(columns=c(1,3:4),digits=3)
    })
    chktxt<-chkout[[2]]
    chktxt$call<-NULL
    output$chktxt<-renderText({old<-options(width=172);on.exit(options(old))
                               paste(capture.output(summary(chktxt)),collapse="\n")})
#    updateVarSelectInput(session,"psavars",data=ds2)
    shinyjs::enable("chkbut")
    output$chkbut <- downloadHandler(
     filename = function() {
       "Check.csv"
     },
     content = function(file) {
       write.csv(chktab,file,row.names=TRUE)
     }
    )
  } else if((input$anal=="psa")&(!is.null(input$psavars))){
    shinyjs::disable("analyze")
    shinyjs::disable("psabut")
    shinyjs::disable("datbut2")
    ds2<-datau %>% dplyr::select(!!!input$psavars)
    covs<-covs2<-colnames(ds2)
    if (length(input$checkvars)>0){
         ds2<-datau %>% dplyr::select(!!!input$checkvars)
         covs2<-colnames(ds2)
    }
    psaout<-psa(input,covs,covs2)
    if (!is.null(psaout)){
      showTab(inputId="tabSelected",target="psa")
      updateTabsetPanel(session,"tabSelected","psa")
      updateSelectInput(session,"usepsa",choices=c(TRUE,FALSE),selected=TRUE)
      psatab<-psaout[[1]]
      psatabo<-psatab
      psatabo$x<-""  
      output$psatab<-renderDT({
      colnames(psatabo)[5]<-" "
      dt<-datatable(psatabo,rownames=TRUE,options=list(pageLength=5,columnDefs=list(list(targets=5,width='400px'),
                                                                   list(targets=c(1:4),width='70px')))) %>%   
#              formatStyle(0,target="row",backgroundColor=styleRow(seq(1,nrow(psatab),2),"lightgrey")) %>%
              formatRound(columns=c(1,3:4),digits=3)
      })
      psatxt<-psaout[[2]]
      psatxt$call<-NULL
      output$psatxt<-renderText({old<-options(width=172);on.exit(options(old))
                               paste(capture.output(summary(psatxt)),collapse="\n")})
      shinyjs::enable("psabut")
      output$psabut <- downloadHandler( 
       filename = function() {
       "PSA.csv"
      },
      content = function(file) {write.csv(psatab,file,row.names=TRUE)})

      output$datbut2 <- downloadHandler(
       filename = function() {
         "PSAData.csv"
       },
       content = function(file) {write.csv(psads,file,row.names=FALSE)})
      shinyjs::enable("psabut")
      if (input$usewos==FALSE) shinyjs::enable("datbut2")
    }
  } else if ((input$anal == "mi")&(length(input$items)>0)){
    shinyjs::disable("analyze")
    shinyjs::disable("mibut")
    shinyjs::disable("mimodbut")
    showTab(inputId="tabSelected",target="mi")
    updateTabsetPanel(session,"tabSelected","mi")
    ds2<-datau %>% dplyr::select(!!!input$items)
    items<-colnames(ds2)
#print("kim1")
#print(items)
#print(scales)
    if (input$usepsa){
      mioutt<-capture.output(mi(psads,input$group,items))
      miout<-mi(psads,input$group,items)
    } else {
      mioutt<-capture.output(mi(datau,input$group,items))
      miout<-mi(datau,input$group,items)
    }
#print("kim2")
    mioutl<-miout
    dt<-datatable(mioutl,rownames=TRUE,options=list(scrollX=TRUE)) %>%  
              formatRound(columns=c(1,3:8,10:15),digits=3)
    mioutt<-mioutt[-c((length(mioutt)-((nrow(mioutl)+1)*3)):length(mioutt))]
    output$mimodbut <- downloadHandler(
       filename = function() {
         "MeasurementInvariateModel.txt"
     },
     content = function(file) {
       writeLines(mioutt,file)
     }
     )

    output$mitab<-renderDT(dt)
    output$mibut <- downloadHandler(
     filename = function() {
       "MI.csv"
     },
     content = function(file) {
       write.csv(miout,file,row.names=TRUE)
     }
    )
    shinyjs::enable("mibut")
    shinyjs::enable("mimodbut")
  } else if ((input$anal == "metric")&(length(input$items)>2)){
    shinyjs::disable("analyze")
    shinyjs::disable("metricbut")
    shinyjs::disable("metricmodbut")
    showTab(inputId="tabSelected",target="metric")
    updateTabsetPanel(session,"tabSelected","metric")
    items<-input$items
    ds2<-datau %>% dplyr::select(!!!input$items)
    if (input$usepsa){
      configout<-config(psads,input$group,items)
    } else {
      configout<-config(datau,input$group,items)
    }
    metricOut<-compareItems(configout$model,configout$config,input$scales)
    metricOutt<-capture.output(compareItems(configout$model,configout$config,input$scales))
    metricOutt<-metricOutt[-c((length(metricOutt)-((nrow(metricOut)+1)*3)):length(metricOutt))]
    output$metricmodbut <- downloadHandler(
       filename = function() {
         "MetricInvarianceModel.txt"
     },
     content = function(file) {
       writeLines(metricOutt,file)
     }
     )

    nonInvar<-metricOut[(!is.na(metricOut[,"delta p"])& metricOut[,"delta p"]<input$threshold),]
    k<-length(grep(input$scales,colnames(ds2)))
    if ((nrow(nonInvar)>0) & (nrow(nonInvar)< (k*(k-1)/2))){
      itemSubsets<-listandDelete(k,strsplit(rownames(nonInvar),"-"))
      itemSubsetOut<-NULL
      for (i in 1:length(itemSubsets)){
        x<-paste(input$scales,itemSubsets[[i]],sep="")
        x<-paste(x,collapse=",")
        if (i==1){
          itemSubsetOut<-paste(itemSubsetOut,x,sep="")
        }else{
          itemSubsetOut<-paste(itemSubsetOut,x,sep="; ")
        }
      }
    }else if (nrow(nonInvar)==0){
      im<-metricOut[-1,1]
      im<-strsplit(im,"-")
      x<-NULL
      for (i in 1:length(im)){
        x<-c(x,im[[i]])
      }
      x<-as.factor(x)
      itemSubsetOut<-levels(x)
    } else {
      itemSubsetOut<-"None"
    }
    itemSubsetOut<-c("Subsets of invariant items: ",itemSubsetOut)
    output$metrictxt<-renderText({itemSubsetOut})
    output$metricbut <- downloadHandler(
     filename = function() {
       "METRIC.csv"
     },
     content = function(file) {
       write.csv(metricOut,file,row.names=TRUE)
     }
    )
    metricOutl<-metricOut
    dt<-datatable(metricOutl,rownames=FALSE,options=list(scrollX=TRUE)) %>%  
              formatRound(columns=c(2,4:9,11:16),digits=3)
    output$metrictab<-renderDT(dt)
    shinyjs::enable("metricbut")
    shinyjs::enable("metricmodbut")
  } else if ((input$anal == "scalar")&(input$scales!="None")){
    if (length(input$loadings)==0) {
      loads<-""
    }else{
      ds2<-datau %>% dplyr::select(!!!input$loadings)
      loads<-colnames(ds2)
    }
    shinyjs::disable("analyze")
    shinyjs::disable("scalarbut")
    shinyjs::disable("scalarmodbut")
    showTab(inputId="tabSelected",target="scalar")
    updateTabsetPanel(session,"tabSelected","scalar")
    ds2<-datau %>% dplyr::select(!!!input$items)
    items<-colnames(ds2)
    if (input$usepsa){
      metricout<-metric(psads,input$group,items,loads)
    } else {
      metricout<-metric(datau,input$group,items,loads)
    }
    scalarOut<-compareItems(metricout$model,metricout$metric,input$scales,loads)
    scalarOutt<-capture.output(compareItems(metricout$model,metricout$metric,input$scales,loads))
    scalarOutt<-scalarOutt[-c((length(scalarOutt)-((nrow(scalarOut)+1)*3)):length(scalarOutt))]
    output$scalarmodbut <- downloadHandler(
       filename = function() {
         "ScalarInvarianceModel.txt"
     },
     content = function(file) {
       writeLines(scalarOutt,file)
     }
     )

    nonInvar<-scalarOut[(!is.na(scalarOut[,"delta p"])& scalarOut[,"delta p"]<input$threshold),]
    k<-length(grep(input$scales,colnames(ds2)))
    if ((nrow(nonInvar)>0) & (nrow(nonInvar)< (k*(k-1)/2))){
      itemSubsets<-listandDelete(k,strsplit(rownames(nonInvar),"-"))
      itemSubsetOut<-NULL
      for (i in 1:length(itemSubsets)){
        x<-paste(input$scales,itemSubsets[[i]],sep="")
        x<-paste(x,collapse=",")
        if (i==1){
          itemSubsetOut<-paste(itemSubsetOut,x,sep="")
        }else{
          itemSubsetOut<-paste(itemSubsetOut,x,sep="; ")
        }
      }
    }else if (nrow(nonInvar)==0){
      im<-scalarOut[-1,1]
      im<-strsplit(im,"-")
      x<-NULL
      for (i in 1:length(im)){
        x<-c(x,im[[i]])
      }
      x<-as.factor(x)
      itemSubsetOut<-levels(x)
    } else {
      itemSubsetOut<-"None"
    }
    itemSubsetOut<-c("Subsets of invariant items: ",itemSubsetOut)
    output$scalartxt<-renderText({itemSubsetOut})
    output$scalarbut <- downloadHandler(
     filename = function() {
       "SCALAR.csv"
     },
     content = function(file) {
       write.csv(scalarOut,file,row.names=TRUE)
     }
    )
    scalarOutl<-scalarOut
    dt<-datatable(scalarOutl,rownames=FALSE,options=list(scrollX=TRUE)) %>%  
              formatRound(columns=c(2,4:9,11:16),digits=3)
    output$scalartab<-renderDT(dt)
    shinyjs::enable("scalarbut")
    shinyjs::enable("scalarmodbut")
  } else if ((input$anal == "latent")&(length(input$items)>0)){

    if (length(input$intercepts)==0) {
      icepts<-""
    }else{
      ds2<-datau %>% dplyr::select(!!!input$intercepts)
      icepts<-colnames(ds2)
    }
    if (length(input$loadings)==0) {
      loads<-""
    }else{
      ds2<-datau %>% dplyr::select(!!!input$loadings)
      loads<-colnames(ds2)
    }
    shinyjs::disable("analyze")
    shinyjs::disable("latentbut")
    shinyjs::disable("latentmodbut")
    showTab(inputId="tabSelected",target="latent")
    updateTabsetPanel(session,"tabSelected","latent")
    ds2<-datau %>% dplyr::select(!!!input$items)
    items<-colnames(ds2)
    if ((loads[1]!="") && (icepts[1]=="")){ 
      showNotification("All items with factor loadings to be freely estimates should be freely estimated in subsequent models.",type="error")   
    }else if ((loads[1]!="") &(sum(is.na(match(loads,icepts)))>0)){
       showNotification("All items with factor loadings to be freely estimates should be freely estimated in subsequent models.",type="error") 
    }else{
      if (input$usepsa){
        tout<-lmean(psads,input$group,items,loads,icepts,input$means)
        referent<-levels(as.factor(psads[,input$group]))[1]
        latentoutt<-capture.output(lmean(psads,input$group,items,loads,icepts,input$means))
        latentoutt<-latentoutt[-c((length(latentoutt)-(12+2*nrow(tout$out3))):length(latentoutt))]
      } else {
        tout<-lmean(datau,input$group,items,loads,icepts,input$means)
        referent<-levels(as.factor(datau[,input$group]))[1]
        latentoutt<-capture.output(lmean(datau,input$group,items,loads,icepts,input$means))
        latentoutt<-latentoutt[-c((length(latentoutt)-(12+2*nrow(tout$out3))):length(latentoutt))]
      }
      output$latenttxt<-renderText({old<-options(width=172);on.exit(options(old))
                               paste(latentoutt,collapse="\n")})
      output$latentbut <- downloadHandler(
        filename = function() {
        "LATENT.csv"
      },
      content = function(file) {
        write.csv(tout$models,file,row.names=TRUE)
      }
      )
      output$latentbut2 <- downloadHandler(
        filename = function() {
        "LATENTMEANS.csv"
      },
      content = function(file) {
        write.csv(tout$out3,file,row.names=FALSE)
      }
      )
     output$latentmodbut <- downloadHandler(
       filename = function() {
         "StructuralInvarianceModel.txt"
      },
      content = function(file) {
        writeLines(latentoutt,file)
      }
      )
      dt<-datatable(tout$models,rownames=TRUE,options=list(scrollX=TRUE)) %>%  
              formatRound(columns=c(1,3:8,10:15),digits=3)
      output$latenttab<-renderDT(dt)
      dt2<-datatable(tout$out3,rownames=FALSE,
              caption=paste("Latent Mean Differences from Scalar Model. ",input$group," = ",referent," used as referent"),
              options=list(scrollX=TRUE,pageLength=6)) %>% 
              formatRound(columns=c(3:ncol(tout$out3)),digits=3)
      output$latenttab2<-renderDT(dt2)
      shinyjs::enable("latentbut")
      shinyjs::enable("latentmodbut")
      shinyjs::enable("latentbut2")
    }
  }

})

}

library(bslib)
library(dplyr)
library(DT)
library(foreign)
library(lavaan)
library(lsr)
library(MatchIt)
library(Matching)
library(rgenoud)
library(shiny)
library(shinyjs)
library(stringr)

source("calmSupport.R")
#source("FRfuncsModified.R")

datau<<-read.csv("Dummy.csv")
datau<<-NULL


jsCode <- "
shinyjs.init = function() {
  $('#tabSelected li a[data-value=\"check\"]').parent().hide();
  $('#tabSelected li a[data-value=\"psasetup\"]').parent().hide();
  $('#tabSelected li a[data-value=\"psa\"]').parent().hide();
  $('#tabSelected li a[data-value=\"mi\"]').parent().hide();
  $('#tabSelected li a[data-value=\"metric\"]').parent().hide();
  $('#tabSelected li a[data-value=\"scalar\"]').parent().hide();
  $('#tabSelected li a[data-value=\"latent\"]').parent().hide();
}
"

source("FRFuncsModified.R")

psacall<-function(input,cov,covs){

group<-input$group
seed<-input$seed

dspsm<-datau

form<-paste(group,"~",sep="")
for (i in 1:length(covs)){
  if (i!=length(covs)){
    form<-paste(form,covs[i],"+",sep="")
  }else{
    form<-paste(form,covs[i],sep="")
  }
}

return(paste("matchit(",form,", data=dspsm, method='nearest', caliper=.2, pop.size=1000)",sep=""))

#return("matchit(USA~SelfEmp+PrivateOrg,data=dspsm,method='genetic',distance='glm',link='logit',caliper=.2,replace=FALSE,pop.size=1000)")
}
lmean<-function(ds,group,items,loadings,intercepts,means){

  ds[,group]<-as.factor(ds[,group])
  mi<-NULL
  mx<-NULL
  itemsx<-NULL
  si2<-NULL
  M2<-NULL
  si<-vector("list",length(scales))
  gp<-NULL
  for (i in 1:length(scales)){
    itemsx<-items[grepl(scales[i],items)]
    if(length(loadings)>0){
      loadingsx<-loadings[grepl(scales[i],loadings)]
      if (length(loadingsx)>0){
        m<-match(loadingsx,itemsx)
        itemsx<-c(itemsx[-m],itemsx[m])
      }
    }
    mx<-paste(scales[i],"=~",paste(itemsx,collapse="+"))
    if (!is.null(M2)){
      M2<-paste(M2,mx,sep="\n ")
    }else{
      M2<-mx
    }
  }

  for (i in 1:length(scales)){
    itemsx<-items[grepl(scales[i],items)]
    if(length(loadings)>0){
      loadingsx<-loadings[grepl(scales[i],loadings)]
      if (length(loadingsx)>0){
        m<-match(loadingsx,itemsx)
        itemsx<-c(itemsx[-m],itemsx[m])
      }
    }
    mx<-paste(scales[i],"=~",paste(itemsx,collapse="+"))
    si[[i]]<-paste(scales[i],"~c(",sep="")
    grpest<-paste(scales[i],"g",levels(ds[,group]),sep="")
    si[[i]]<-paste(si[[i]],paste(grpest,collapse=","),")*1","\n ",sep="")
    si[[i]]<-paste(si[[i]],scales[i],"diff := ",paste(grpest,collapse="-"),sep="")
    si2<-paste(si2,paste(scales[i],"~1"),sep="\n ")
    itemsx<-items[grepl(scales[i],items)]
    if(length(intercepts)>0){
      interceptsx<-intercepts[grepl(scales[i],intercepts)]
      if (length(interceptsx)>0){
        m<-match(interceptsx,itemsx)
        itemsx<-c(itemsx[-m],itemsx[m])
      }
    }
    for (j in 1:length(itemsx)){
      if (j==1){
        mxj<-paste(itemsx[j],"~","0")
      } else {
        mxj<-paste(mxj,paste(itemsx[j],"~","1"),sep="\n ")
      }
    }
    mx<-paste(mx,mxj,sep="\n ")
    if (!is.null(mi)){
      mi<-paste(mi,mx,sep="\n ")
    }else{
      mi<-mx
    }
  }
#  M2<-paste(mi,paste(si,collapse="\n "),sep="\n ")
  M3<-paste(mi,si2,sep="\n ")
  gp<-NULL

  if(length(intercepts)>0){
    for (i in 1:length(intercepts)){
      mx<-paste(intercepts[i],1,sep="~")
      gp<-c(gp,mx)
    }
  }

  if(length(loadings)>0){
    for (i in 1:length(loadings)){
      mx<-paste(substr(loadings[i],1,2),loadings[i],sep="=~")
      gp<-c(gp,mx)
    }
  }
  scalar<-cfa(M2,ds,group=group,group.equal=c("loadings","intercepts"),group.partial=gp)

  sscalar<-standardizedSolution(scalar)
  pscalar<-parameterEstimates(scalar)
  oute<-NULL
  outd<-NULL
  for (i in 1:length(levels(ds[,group]))){
    pscalarl<-subset(pscalar,group==i)
    sscalarl<-subset(sscalar,group==i)
    oute<-rbind(oute,pscalarl[(nrow(pscalarl)-(length(scales)-1)):nrow(pscalarl),])
    outd<-rbind(outd,sscalarl[(nrow(sscalarl)-(length(scales)-1)):nrow(sscalarl),])
  }
  out3<-cbind(oute,outd$est)
  out3<-out3[,-c(2:4,6)]
  out3$group<-as.factor(out3$group)
  levels(out3$group)<-levels(ds[,group])
  colnames(out3)[c(1,2,9)]<-c("scale",group,"d")
  out3<-na.omit(out3)
  if (!is.null(means)){
    gp<-c(gp,paste(means,1,sep="~"))
  }
  structural<-cfa(M3,ds,group=group,group.equal=c("loadings","intercepts","means"),group.partial=gp)

  models<-matrix(nrow=2,ncol=15)
  models<-as.data.frame(models)
  rownames(models)<-c("scalar","structural")
  colnames(models)<-c("x2","df","CFI","RMSEA","SRMR","AIC","BIC","delta x2","delta df","delta p","delta CFI","delta RMSEA","delta SRMR","delta AIC","delta BIC")
  models<-miData(models,scalar,"scalar")
  models<-miData(models,structural,"structural","scalar")

  return(list(models=models,out3=out3))
}

config<-function(ds,group,items){
  M0<-NULL
  for (i in 1:length(scales)){
    mx<-paste(scales[i],"=~",paste(itemsx<-items[grepl(scales[i],items)],collapse="+"))
    mx<-paste(mx,paste(scales[i],"~1"),sep="\n ")
    for (j in 1:length(itemsx)){
      if (j==1){
        mxj<-paste(itemsx[j],"~","0")
      } else {
        mxj<-paste(mxj,paste(itemsx[j],"~","1"),sep="\n ")
      }
    }
    mx<-paste(mx,mxj,sep="\n ")
    if (!is.null(M0)){
      M0<-paste(M0,mx,sep="\n ")
    }else{
      M0<-mx
    }
  }
  config<-cfa(M0,ds,group=group)
  return(list(model=M0,config=config))
}

metric<-function(ds,group,items,loadings){
  M0<-NULL
  for (i in 1:length(scales)){
    itemsx<-items[grepl(scales[i],items)]
    if(length(loadings)>0){
      loadingsx<-loadings[grepl(scales[i],loadings)]
      if (length(loadingsx)>0){
        m<-match(loadingsx,itemsx)
        itemsx<-c(itemsx[-m],itemsx[m])
      }
    }
    mx<-paste(scales[i],"=~",paste(itemsx,collapse="+"))
    mx<-paste(mx,paste(scales[i],"~1"),sep="\n ")
    for (j in 1:length(itemsx)){
      if (j==1){
        mxj<-paste(itemsx[j],"~","0")
      } else {
        mxj<-paste(mxj,paste(itemsx[j],"~","1"),sep="\n ")
      }
    }
    mx<-paste(mx,mxj,sep="\n ")
    if (!is.null(M0)){
      M0<-paste(M0,mx,sep="\n ")
    }else{
      M0<-mx
    }
  }
  gp<-NULL
  if (length(loadings)>0){
    for (i in 1:length(loadings)){
      mx<-paste(substr(loadings[i],1,2),loadings[i],sep="=~")
      gp<-c(gp,mx)
    }
  }
  metric<-cfa(M0,ds,group=group,group.equal=c("loadings"),group.partial=gp)
  return(list(model=M0,metric=metric))
}

mi<-function(ds,group,items){
 
#print(scales)
#print(items)
  configout<-config(ds,group,items)
  return(compareScales(configout$model,configout$config))


}

psacheck<-function(group,covs,seed){


form<-paste(group,"~",sep="")
for (i in 1:length(covs)){
  if (i!=length(covs)){
    form<-paste(form,covs[i],"+",sep="")
  }else{
    form<-paste(form,covs[i],sep="")
  }
}
set.seed(seed)
m.out <- matchit(as.formula(form), data = datau, method = NULL, distance = "glm")


  psacheck<-matrix(nrow=length(covs),ncol=4)
  rownames(psacheck)<-covs
  colnames(psacheck)<-c("x2","df","p","Cramer V")
  ds<-datau
  ds[,group]<-factor(ds[,group])
  for (i in 1:length(covs)){
    ds[,covs[i]]<-factor(ds[,covs[i]])
    x.out<-chisq.test(tout<-table(ds[,covs[i]],ds[,group]),correct=FALSE)
    psacheck[i,"x2"]<-x.out$statistic[[1]]
    psacheck[i,"df"]<-x.out$parameter[[1]]
    psacheck[i,"p"]<-x.out$p.value[[1]]
    psacheck[i,"Cramer V"]<-cramersV(tout)
  }
psacheck<-as.data.frame(psacheck)


return(list(chktab=psacheck,chksum=m.out))

}
 
psa<-function(input,covs,covs2){

group<-input$group
seed<-input$seed

dspsm<-datau

form<-paste(group,"~",sep="")
for (i in 1:length(covs)){
  if (i!=length(covs)){
    form<-paste(form,covs[i],"+",sep="")
  }else{
    form<-paste(form,covs[i],sep="")
  }
}

#m.out <- matchit(as.formula(form), data = dspsm, method = input$method, distance = input$distance, link = input$link, caliper=input$caliper, replace = input$replace, pop.size = input$pop.size)

if(input$psaarg==TRUE){
  expr<-parse(text=mcall)
}else{
  err<-tryCatch(expr<-parse(text= input$ccall),error=function(w){w})
#  expr<-parse(text=input$ccall)
  if (inherits(err, "error")){ 
    showNotification(err$message,type="error")
    return(NULL)
  }
}

#m.out<-eval(expr)

set.seed(seed)

err <- NULL  # Initialize error variable

# Use tryCatch to prevent system crash on error
m.out <- tryCatch(
  {
    withCallingHandlers(
      {
        eval(expr)
      },
      warning = function(w) {
        showNotification(w$message)
        invokeRestart("muffleWarning")  # Prevent warning from printing
      }
    )
  },
  error = function(e) {
    showNotification(e$message,type="error",duration=30,id="psasetup")
    err <<- e  # Store the error
    return(NULL)  # Return NULL to avoid system crash
  }
)

if  (!is.null(err)){
  return(NULL)
}else{
  removeNotification(id="psasetup")
}

#extract datafile (m.data) with matched cases
psads<<-match.data(object=m.out, group="all", distance = "distance", weights = "weights")

  psa<-matrix(nrow=length(covs2),ncol=4)
  rownames(psa)<-covs2
  colnames(psa)<-c("x2","df","p","Cramer V")
  ds<-psads
  ds[,group]<-factor(ds[,group])
  for (i in 1:length(covs2)){
    ds[,covs2[i]]<-factor(ds[,covs2[i]])
    x.out<-chisq.test(tout<-table(ds[,covs2[i]],ds[,group]),correct=FALSE)
    psa[i,"x2"]<-x.out$statistic[[1]]
    psa[i,"df"]<-x.out$parameter[[1]]
    psa[i,"p"]<-x.out$p.value[[1]]
    psa[i,"Cramer V"]<-cramersV(tout)
  }
psa<-as.data.frame(psa)

return(list(psatab=psa,psasum=m.out))
}

miData<-function(models,model,id,compare=NULL){
  if (colnames(models)[1]=="ref-noninv"){
    print(models[id,"ref-noninv"])
  }else{
    print(id)
  }
  print(summary(model,standardized=TRUE,fit.measures=TRUE))
  fit<-as.data.frame(fitMeasures(model))
  models[id,"df"]<-fit["df",]
  models[id,"AIC"]<-fit["aic",]
  models[id,"BIC"]<-fit["bic",]
  models[id,"x2"]<-fit["chisq",]
  models[id,"CFI"]<-fit["cfi",]
  models[id,"RMSEA"]<-fit["rmsea",]
  models[id,"SRMR"]<-fit["srmr",]
  if (!is.null(compare)){
    models[id,"delta x2"]<-models[id,"x2"]-models[compare,"x2"]
    models[id,"delta df"]<-models[id,"df"]-models[compare,"df"]
    models[id,"delta CFI"]<-models[id,"CFI"]-models[compare,"CFI"]
    models[id,"delta RMSEA"]<-models[id,"RMSEA"]-models[compare,"RMSEA"]
    models[id,"delta SRMR"]<-models[id,"SRMR"]-models[compare,"SRMR"]
    models[id,"delta AIC"]<-models[id,"AIC"]-models[compare,"AIC"]
    models[id,"delta BIC"]<-models[id,"BIC"]-models[compare,"BIC"]
    models[id,"delta p"]<-pchisq(models[id,"delta x2"],models[id,"delta df"],lower.tail=FALSE)
  }
  return(invisible(models))
}

compareScales<-function(M1,fit){

lo<-lavInspect(fit,"list")
lo1<-subset(lo,(free==0)&(op=="=~"))
vars<-names(table(lo1$lhs))
varitem<-NULL
varitem<-vector("list",length(vars))
fitl<-NULL
ds1<-lavInspect(fit,"data")
ds2<-NULL

lox<-subset(lo,(user==1) & (block==1) & (op=="=~"))[,c("lhs","op","rhs")]

for (i in 1:length(ds1)){
  ds1a<-ds1[i]
  ds1b<-ds1a[[names(ds1a)]]
  ds1b<-as.data.frame(ds1b)
  ds1b$grp<-i
  rownames(ds1b)<-lavInspect(fit,"case.idx")[[names(ds1a)]]
  ds2<-rbind(ds2,ds1b)
}

colnames(ds2)<-c(lavNames(fit),"grp")

models<-matrix(nrow=length(vars)*2+3,ncol=15)
models<-as.data.frame(models)

rownames(models)<-c("configural","metric",paste("metric",vars,sep="-"),"scalar",paste("scalar",vars,sep="-"))
colnames(models)<-c("x2","df","CFI","RMSEA","SRMR","AIC","BIC","delta x2","delta df","delta p","delta CFI","delta RMSEA","delta SRMR","delta AIC","delta BIC")

model<-cfa(M1,ds2,group="grp")
invisible(models<-miData(models,model,"configural"))

model<-cfa(M1,ds2,group="grp",group.equal=c("loadings"))
models<-miData(models,model,"metric","configural")

for (i in 1:length(vars)){
  gp<-subset(lox,lhs!=vars[i])
  gp<-paste(gp$lhs,gp$rhs,sep="=~")
  model<-cfa(M1,ds2,group="grp",group.equal=c("loadings"),group.partial=gp)
  models<-miData(models,model,paste("metric",vars[i],sep="-"),"configural")
}

model<-cfa(M1,ds2,group="grp",group.equal=c("loadings","intercepts"))
models<-miData(models,model,"scalar","metric")

for (i in 1:length(vars)){
  gp<-subset(lox,lhs!=vars[i])
  gp<-paste(gp$rhs,"~1",sep=" ")
#  print(gp)
  model<-cfa(M1,ds2,group="grp",group.equal=c("loadings","intercepts"),group.partial=gp)
  models<-miData(models,model,paste("scalar",vars[i],sep="-"),"metric")
}

return(models)
}

compareItems<-function(M1,fit,scale,loadings=""){

lo<-lavInspect(fit,"list")
lo1<-subset(lo,free==0)
vars<-names(table(lo1$lhs))
varitem<-NULL
varitem<-vector("list",length(vars))
fitl<-NULL
ds1<-lavInspect(fit,"data")
ds2<-NULL

lox<-subset(lo,(user==1) & (block==1))[,c("lhs","op","rhs")]

for (i in 1:length(ds1)){
  ds1a<-ds1[i]
  ds1b<-ds1a[[names(ds1a)]]
  ds1b<-as.data.frame(ds1b)
  ds1b$grp<-i
  rownames(ds1b)<-lavInspect(fit,"case.idx")[[names(ds1a)]]
  ds2<-rbind(ds2,ds1b)
}

colnames(ds2)<-c(lavNames(fit),"grp")

vlox<-subset(lo,(op=="=~") & (group==1)& (lhs==scale))

vlox2<-subset(lo,(op=="=~") & (group==1)& (lhs==scale) & (rhs!=loadings))


comb<-combn(1:nrow(vlox2),2)
vars<-paste(comb[1,],comb[2,],sep="-")

comb2<-combn(vlox2$rhs,2)
vars2<-paste(comb2[1,],comb2[2,],sep="-")

models<-matrix(nrow=length(vars)+1,ncol=16)
models<-as.data.frame(models)

if (length(fit@Options$group.equal)==0){

  rownames(models)<-c("configural",vars)
  colnames(models)<-c("ref-noninv","x2","df","CFI","RMSEA","SRMR","AIC","BIC","delta x2","delta df","delta p","delta CFI","delta RMSEA","delta SRMR","delta AIC","delta BIC")
  models[,"ref-noninv"]<-c("configural",vars2)

  mc<-cfa(M1,ds2,group="grp")
  models<-miData(models,mc,"configural")

  vitems<-vlox$rhs
  sitems<-subset(lo,(op=="=~") & (group==1)& (lhs!=scale))[,c("lhs","op","rhs")]
  sscale<-table(sitems$lhs)
  sm1<-NULL

  if (length(sscale)!=0){
    for (i in 1:length(sscale)){
      items<-subset(sitems,lhs==names(sscale[i]))
      items<-items$rhs
      items<-paste(items,collapse="+")
      items<-paste(names(sscale[i]),items,sep="=~")
      sm1<-paste(sm1,items,sep="\n ")
    }
  }
  sgp<-subset(lox,(lhs!=scale)&(op!="~1"))
  sgp<-paste(sgp$lhs,sgp$rhs,sep="=~")

  k<-length(vitems)
  for (i in 1:(k-1)){
    vitemx<-vitems[i:k]
    if (i>1){
      vitemx<-c(vitemx,vitems[1:(k-length(vitemx))])
    }
    vitemx<-paste(vitemx,collapse="+")
    vitemx<-paste(scale,vitemx,sep="=~")
    m1<-paste(vitemx,sm1,sep="\n ")
    for (j in (i+1):k){
      vgp<-vlox[-j,]
      vgp<-paste(vgp$lhs,vgp$rhs,sep="=~")
      gp<-c(sgp,vgp)
      id<-paste(i,j,sep="-")
      model<-cfa(m1,ds2,group="grp",group.equal=c("loadings"),group.partial=gp)
      models<-miData(models,model,id,"configural")
    }
  }
}
else {

  rownames(models)<-c("metric",vars)
  colnames(models)<-c("ref-noninv","x2","df","CFI","RMSEA","SRMR","AIC","BIC","delta x2","delta df","delta p","delta CFI","delta RMSEA","delta SRMR","delta AIC","delta BIC")
  models[,"ref-noninv"]<-c("metric",vars2)

  gp<-NULL
  if (length(loadings)>0){
    for (i in 1:length(loadings)){
      mx<-paste(substr(loadings[i],1,2),loadings[i],sep="=~")
      gp<-c(gp,mx)
    }
  }
  lgp<-gp

  mc<-cfa(M1,ds2,group="grp",group.equal=c("loadings"),group.partial=gp)
  models<-miData(models,mc,"metric")

  vitems<-vlox$rhs
  sitems<-subset(lo,(op=="=~") & (group==1)& (lhs!=scale))[,c("lhs","op","rhs")]
  sscale<-table(sitems$lhs)
  sm1<-NULL

  if (length(sscale)!=0){
    for (i in 1:length(sscale)){
      items<-subset(sitems,lhs==names(sscale[i]))
      items<-items$rhs
      sml0<-paste(items[1],"\n",sep="~0")
      sml1<-paste(items[-1],"\n",sep="~1")
      sml1<-paste(sml1,collapse=" ")
      sm12<-paste(sml0,sml1,sep=" ")
      sm1<-paste(sm1,sm12,sep=" ")
      items<-subset(sitems,lhs==names(sscale[i]))
      items<-items$rhs
      items<-paste(items,collapse="+")
      items<-paste(names(sscale[i]),items,sep="=~")
      sm1<-paste(items,sm1,sep="\n ")
      sc<-paste(names(sscale[i]),"\n",sep="~1")
      sm1<-paste(sm1,sc,sep=" ")
    }
  }
  sgp<-subset(lox,(lhs!=scale)&(op!="~1"))
  sgp<-paste(sgp$rhs,"~1",sep=" ")

  k<-length(vitems)
  for (i in 1:(k-1)){
    vitemxs<-vitems[i:k]
    if (i>1){
      vitemxs<-c(vitemxs,vitems[1:(k-length(vitemxs))])
    }
    vitemx<-paste(vitemxs,collapse="+")
    vitemx<-paste(scale,vitemx,sep="=~")
    m1<-paste(vitemx,sm1,sep="\n ")
    vml0<-paste(vitemxs[1],"\n",sep="~0")
    vml1<-paste(vitemxs[-1],"\n",sep="~1")
    vml1<-paste(vml1,collapse=" ")
    vm1<-paste(vml0,vml1,sep=" ")
    sc<-paste(scale,"\n",sep="~1")
    vm1<-paste(vm1,sc,sep=" ")
    m1<-paste(m1,vm1,sep=" ")
    for (j in (i+1):k){
      vgp<-vlox[-j,]
      vgp<-paste(vgp$rhs,"1",sep="~")
      gp<-c(lgp,sgp,vgp)
      id<-paste(i,j,sep="-")
      if (!is.na(models[id,"ref-noninv"])){
        model<-cfa(m1,ds2,group="grp",group.equal=c("loadings","intercepts"),group.partial=gp)
        models<-miData(models,model,id,"metric")
      }
    }
  }

}
return(models)
}
 

listandDelete<-function(k,nonVars,names=NULL){

allVars<-c(1:k)
total<-sum(ids<-2^(allVars-1))
aps<-c(1:(total-1))
aps<-as.data.frame(aps)
ids<-as.data.frame(ids)
aps<-subset(aps,!(aps %in% ids$ids))
bitsB<-NULL
id<-NULL

for (i in 1:nrow(aps)){
  bits<-as.integer(intToBits(aps$aps[i])[1:nrow(ids)])
  bitsB<-rbind(bitsB,bits)
  aps$k[i]<-sum(bits)
  for (j in 1:length(nonVars)){
    if( (bits[as.numeric(nonVars[[j]][1])]==1) & (bits[as.numeric(nonVars[[j]][2])]==1))
      {
      id<-c(id,i)
      }
  }
}

id<-as.data.frame(id[!duplicated(id)])
colnames(id)<-"id"
aps<-cbind(aps,bitsB)

Rule2<-aps[-id$id,]

did<-NULL

for (i in max(Rule2$k):(min(Rule2$k)+1)){
  tempa<-subset(Rule2,k==i)
  if ((nrow(tempa)>0) & (nrow(subset(Rule2,k<i))>0)){
    k2<-max(subset(Rule2,k < i)$k)
    tempb<-subset(Rule2,k<=k2)
    for (j in 1:nrow(tempa)){
      for (k in 1:nrow(tempb)){
        bm<-tempa[j,-c(1,2)]
        cm<-tempb[k,-c(1,2)]
        if (!is.na(bm[1,1]) & !is.na(cm[1,1])){
          if (sum(cm[cm==1]*bm[cm==1])==length(cm[cm==1]))
            did<-c(did,tempb$aps[k])
          }
        }
     }
   }
   did<-did[!duplicated(did)]
   Rule2<-subset(Rule2,!aps %in% did)
   did<-NULL
}

ids<-Rule2[,-c(1,2)]
subsets<-vector("list",nrow(Rule2))
if (!is.null(names)) colnames(ids)<-names
for (i in 1:nrow(ids)){
  subsets[[i]]<-names(ids)[ids[i,]==1]
}
 
return(subsets)
}

ui<-

fluidPage(
#  theme=bslib::bs_theme(bootswatch="spacelab"),
#  shinythemes::themeSelector(),
  shinyjs::useShinyjs(),

  titlePanel("Comprehensive Analysis of Latent Means (CALMs)"),
  sidebarLayout(
    sidebarPanel(
      width=3,
      style="height:90vh; overflow-y:auto;",
      checkboxInput("usewos", tags$a("Use Work Orientations Survey Data (2015)",href="https://search.gesis.org/research_data/ZA6770?doi=10.4232/1.12848"),value=TRUE),
      conditionalPanel(
        condition="(!input.usewos)",
        fileInput("upload", "Upload *Meta.csv and data (.dat, .csv, or .sav)",multiple=TRUE)
      ),
      conditionalPanel(
        condition="(input.anal!='psa')&(input.anal!='check')&(input.anal!='None')",
        selectInput("usepsa", "Use matched data for invariance tests",choices=FALSE),
      ),

      selectInput("anal", "Analysis", choices = c("Check Group Equivalency"='check',"Propensity Score Analysis"='psa',
                                                  "Measurement Invariance"='mi',
                                                  "Metric Invariance"='metric',
                                                  "Scalar Invariance"='scalar',"Structural Invariance"='latent')),
      conditionalPanel(
        condition="(input.anal!='None')",
        selectInput("group", "Grouping Variable", choices = NULL),
      ),
      conditionalPanel(
        condition="((input.anal=='check') | (input.anal=='psa'))",
        selectInput("checkvars", "Covariates to Check",choices=NULL, multiple = TRUE),
      ), 
      conditionalPanel(
        condition="(input.anal=='psa')",
        selectInput("psavars", "Covariates to Equate", choices=NULL,multiple = TRUE),
        numericInput("seed", "Seed for Propensity Score Analysis",value=1234),
        checkboxInput("psaarg","Use Default call to matchit",value=TRUE),
      ), 
      conditionalPanel(
        condition="((input.anal=='mi') | (input.anal=='latent')|(input.anal=='metric')| (input.anal=='scalar'))",
        selectInput("items", "Items to Analyze",choices=NULL,multiple = TRUE),
      ),       
      conditionalPanel(
        condition="((input.anal=='metric')| (input.anal=='scalar'))",
        selectInput("scales", "Scale to Analyze",choices=NULL),
        numericInput("threshold","alpha for Model Comparison Decisions",value=.05,max=1.00),
      ),
      conditionalPanel(
        condition="((input.anal=='latent')|(input.anal=='scalar'))",
        selectInput("loadings", "Loadings to Freely Estimate",choices=NULL,multiple = TRUE)
      ),
      conditionalPanel(
        condition="(input.anal=='latent')",
        selectInput("intercepts", "Intercepts to Freely Estimate", choices=NULL,multiple = TRUE),
        selectInput("means", "Means to Freely Estimate in Structural Model", choices=NULL,multiple = TRUE),
      ),
      input_task_button("analyze", "Analyze")
    ),

mainPanel(
    width=7,
    extendShinyjs(text=jsCode,functions=NULL),
    tags$head(
      tags$script(type = "text/javascript", src = "js/index.js"),
      tags$style(type='text/css',".col-sm-8 {z-index: 999} ")
    ),   
    tabsetPanel(id="tabSelected",type="tabs",
        tabPanel(HTML(paste("Read","Me",sep="<br/>")),
          div(
            style = "height: 800px; width: 100%;overflow-y: auto; padding: 10px; border: 1px solid #ccc;",
            includeHTML("www/intro2.html")
          )
        ),
        tabPanel (HTML(paste("View","Me",sep="<br/>")),value="video",
          htmlOutput("frame")
        ),
        tabPanel (HTML(paste("View","Data",sep="<br/>")),value="data",
          DTOutput("metatab"),
          DTOutput("datatab")
        ),
        tabPanel (HTML(paste("Check Group","Equivalency",sep="<br/>")),value="check",
          h4(""),
          verbatimTextOutput("chktxt"),
          tags$head(tags$style("#chktxt{overflow-y:scroll;max-height:350px;}")),
          DTOutput("chktab")
        ),
        tabPanel (HTML(paste("Propensity Score","Analysis Setup",sep="<br/>")),value="psasetup",
          h4(""),
          uiOutput("mcall"),
          h1(""),
          htmlOutput("ccall")
        ),
        tabPanel (HTML(paste("Propensity Score","Analysis Results",sep="<br/>")),value="psa",
          h4(""),
          verbatimTextOutput("psatxt"),
          tags$head(tags$style("#psatxt{overflow-y:scroll;max-height:350px;}")),
          DTOutput("psatab")
        ),
        tabPanel (HTML(paste("Measurement","Invariance",sep="<br/>")),value="mi",
          h4(""),
          DTOutput("mitab")
        ),
        tabPanel (HTML(paste("Metric","Invariance",sep="<br/>")),value="metric",
          h4(""),
          DTOutput("metrictab"),
          textOutput("metrictxt")
        ),
        tabPanel (HTML(paste("Scalar","Invariance",sep="<br/>")),value="scalar",
          h4(""),
          DTOutput("scalartab"),
          textOutput("scalartxt")
        ),
        tabPanel (HTML(paste("Structural","Invariance",sep="<br/>")),value="latent",
          h4(""),
          DTOutput("latenttab"),
          h4(""),
          DTOutput("latenttab2")
        ),
        tabPanel(HTML(paste("","Downloads",sep="<br/>")),value="down",
               h4(""),
               downloadButton("metbut","Download meta file"),
               h4(""),
               downloadButton("datbut","Download cleaned data"),
               h4(""),
               downloadButton("chkbut","Download check group equivalency table"),
               h4(""),
               downloadButton("psabut","Download post-PSA check group equivalency table"),
               h4(""),
               downloadButton("datbut2","Download post-PSA dataset"),
               h4(""),
               downloadButton("mibut","Download measurement invariance table"),
               h4(""),
               downloadButton("mimodbut","Download measurement invariance model lavaan output"),
               h4(""),
               downloadButton("metricbut","Download metric invariance table"),
               h4(""),
               downloadButton("metricmodbut","Download metric invariance model lavaan output"),
               h4(""),
               downloadButton("scalarbut","Download scalar invariance table"),
               h4(""),
               downloadButton("scalarmodbut","Download scalar invariance model lavaan output"),
               h4(""),
               downloadButton("latentbut","Download structural invariance table"),
               h4(""),
               downloadButton("latentbut2","Download latent means table"),
               h4(""),
               downloadButton("latentmodbut","Download structural invariance model lavaan output")
        )
    )
)
)
)

---
title: "Introduction to CALMs"
output: 
  rmarkdown::html_vignette:
    toc: true
    toc_depth: 2
    mathjax: default
vignette: >
  %\VignetteIndexEntry{Introduction to CALMs}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r setup, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "",
  eval = TRUE
)
```

## Introduction

One of the most basic analyses in social sciences is the ability to compare groups. However, this seemingly straightforward task is often complicated by two significant
 challenges: ensuring group equivalence and assessing measurement invariance. If not adequately addressed, these challenges can lead to misleading conclusions
 and undermine the validity of research findings. This application aims to make the process accessible by integrating
 several advanced statistical techniques including:

- Propensity score analysis (group equivalence checking and propensity score matching)
- Measurement invariance tests (full and partial)
- Structural invariance tests (full and partial)

## Launching CALMs

You can launch the CALMs in one of two ways:

### 1. Web Access (No Installation Required)

Simply visit: [evaluent.shinyapps.io/CALMs](https://evaluent.shinyapps.io/CALMs)

No setup or installation is needed. The application runs directly in your browser.

### 2. Local Access (Installation Required) 

#### A. Open R or RStudio

Make sure R or R studio is installed on your system. Open the application to begin.

#### B. Install the CALMs Package

Run the following in the **R Console**:

```{r, eval = FALSE}
install.packages("calms",dependencies=TRUE)
```

This will install the CALMs package from a local tarball file rather than a CRAN repository to maintain author anonymity while under peer-review.

#### C. Run the CALMs Package

After installing the CALMs package, run the application locally via R with `run_calms()`:

```{r, eval = FALSE}
calms::run_calms()
```

## Built-in Dataset
Users can run CALMs analyses using the dataset built into the application. This built-in dataset is a subset of data from Work 
Orientations IV – ISSP 2015 (ISSP Research Group, 2017) and is included with permission from the ISSP Research Group. 
The subset and modifications applied to the original dataset were generated using the following code:

```{r, eval = FALSE}
###Load necessary packages
library(foreign)
library(haven)

### Read in data set without labels
dso <- 
  read.spss("ZA6770_v2-1-0.sav", 
  use.value.labels=FALSE, max.value.labels=Inf, to.data.frame=TRUE)
nrow(dso)
names(dso)

### Read in data set with labels
dsoa <- 
  read.spss("ZA6770_v2-1-0.sav", 
  use.value.labels=TRUE, max.value.labels=Inf, to.data.frame=TRUE)
nrow(dsoa)
names(dsoa)

### Select only needed columns
#quality of job content (JC: v22-v24) and quality of work environment (WE: v25-v27)
#demographics:SEX,EMPREL,TYPORG2,DEGREE
ds<-subset(dso,select=c(country,v22:v27,SEX,DEGREE,EMPREL,TYPORG2))
names(ds)

ds[,c("country","SEX","DEGREE","EMPREL","TYPORG2")]<-dsoa[,c("country","SEX","DEGREE","EMPREL","TYPORG2")]

###Get data for the groups (i.e., countries)
#country numerical codes in SPSS: UK = 826, US = 840
table(ds$country)
ds<-subset(ds,(country=="GB-Great Britain and/or United Kingdom" | country=="US-United States"))
ds$country<-factor(ds$country)
table(ds$country)
nrow(ds)

###getting rid of missing values 
nrow(ds)
ds<-na.omit(ds)
nrow(ds)

###check values
table(ds$SEX)
table(ds$DEGREE)
table(ds$EMPREL)
table(ds$TYPORG2)
table(ds$country)

levels(ds$EMPREL)<-c("Employee","Self-employed","Self-employed",NA)
levels (ds$DEGREE)<-c(rep("no univ",5),rep("univ",2))

###getting rid of missing values 
nrow(ds)
ds<-na.omit(ds)
nrow(ds)

ds$SEX
levels(ds$SEX)
levels(ds$SEX)<-c(1,0)     #Set "Male" to 1
 
levels(ds$EMPREL)
levels(ds$EMPREL)<-c(0,1)  #Set "Employee" to 1

levels(ds$TYPORG2)
levels(ds$TYPORG2)<-c(0,1) #Set "Private employer" to 1
 
levels(ds$DEGREE)
levels(ds$DEGREE)<-c(0,1)  #Set "univ" to 1

levels(ds$country)
levels(ds$country)<-c(1,0) #Set "US-United States" to 1
 
ds$SEX<-as.numeric(ds$SEX)-1
ds$EMPREL<-as.numeric(ds$EMPREL)-1
ds$TYPORG2<-as.numeric(ds$TYPORG2)-1
ds$DEGREE<-as.numeric(ds$DEGREE)-1
ds$country<-as.numeric(ds$country)-1

nrow(ds)
names(ds)

write_sav(ds,"WosDemo.sav")
```

## Providing Your Own Data

Users can run CALMs analyses on their own datasets. To do so, they must upload two files simultaneously from the same directory:

1. A data file containing the dataset to be analyzed.
2. A corresponding meta file that provides information about the dataset.

The CALMs application supports data files in .csv, .dat, and .sav formats.

The meta file must be a .csv and 
be named such that the last four characters of the file name are "Meta" (e.g., My_Meta.csv, Meta.csv). The meta file must have the column names of *itemo*, 
*item*, *type*, *scale*, *ds*, and *missing*. 

- The column labeled *itemo* identifies the original variable names in the file containing the data to be analyzed. 
- The column labeled *item* identifies corresponding new variable names that will be used when creating the cleaned dataset. 
- The column labeled *type* identifies 
whether the item is a scale item, covariate, or grouping variable. 
- The column labeled *scale* identifies the name of the corresponding scale for scale items. 
- The column labeled *ds* identifies the name of the dataset uploaded that will be cleaned and subsequently analyzed. Note that the user can upload a dataset with 
any number of other variables in addition to those identified in the meta file. 
- The column labeled *missing* identifies a numeric value that denotes how missing 
values are coded. 

A sample meta file is provided below that corresponds to a subset of the 2015 Work Orientations dataset (ISSP Research Group, 2017)
that is built into the CALMs application for demonstration purposes.

```{r, results="markup",echo=FALSE}
library(calms)
data("WosDemoMeta")
WosDemoMeta
```
## Features Overview

The CALMs Shiny application is organized with multiple tabs that each serve a specific purpose:

- Read Me - Displays user manual for the CALMs application. 
- View Me - Displays demonstration video of the CALMs application. 
- View Data – Displays the dataset selected.
- Downloads – Contains links to files that the user can download.
- Check Group Equivalency – Checks group equivalence of selected covariates. 
- Propensity Score Analysis Setup – Provides default call to matchit which the user can override and create custom call. 
- Propensity Score Analysis Results – Upon execution of analysis, provides results of propensity score analysis.
- Measurement Invariance – Upon execution of analysis, provides results of measurement invariance tests for the grouping variable and items to analyze selected. User may also override the default to use matched data for invariance tests.
- Metric Invariance – Upon execution of analysis, provides results of metric invariance tests for the grouping variable, items to analyze, and scale to analyze. User may also override the default to use matched data for invariance tests and modify the alpha for model comparison decisions.
- Scalar Invariance - Upon execution of analysis, provides results of scalar invariance tests for the grouping variable, items to analyze, and scale to analyze. User may also override the default to use matched data for invariance tests, modify the alpha for model comparison decisions, and select items with loadings to freely estimate.  
- Structural Invariance - Upon execution of analysis, provides results of structural invariance tests for the grouping variable and  items to analyze. User may also override the default to use matched data for invariance tests, select items with  loadings to freely estimate, select items with intercepts to freely estimate, and select scales with means to freely estimate.

## Example Workflow

This section walks through the CALMs application interface using screenshots for illustrative purposes. Specifically, we analyze data from 
the 2015 Work Orientations Survey that includes responses from the United States (USA) and the United Kingdom (UK; ISSP Research Group, 2017).
 The 2015 Work Orientations dataset is from an international project that began in 1984 and was collected across 37 countries
 (ISSP Research Group, 2017). 

The portion of the 2015 Work Orientations dataset used for the demonstration includes 1,477 
responses from the USA and 1,793 responses from the UK. We specifically chose the stated two countries because full scalar invariance 
was not supported in previous measurement invariance studies using the constructs quality of job context (JX), quality of job content (JC), 
and quality of work environment (WE) in the measurement model using the 1989 Work Orientations dataset (Cheung & Lau, 2012; Cheung & Rensvold,
 1999). 

The 2015 Work Orientations dataset provided data for two of these previously utilized constructs, JC and WE (ISSP Research Group, 2017).
 Each construct is measured by three items, scored on a five-point Likert-type scale ranging from 1 (strongly agree) to 5 (strongly disagree).
Figure 1 depicts the 2-factor measurement model used in the illustrative example. What follows next is a recommend set of steps to comprehensively
analyze the latent means of JC and WE by country, where country is either USA or UK. Note that researchers may
choose to use the application in a different way that the example workflow and skip tests if that fits their research scenario.

<img src="images/Figure1.png" style="border: 1px solid black; padding: 5px;" width="300">

**Figure 1.** *Measurement Model* 

### Step 1: Load Data

Users can either use the built-in dataset by leaving Use 2015 Work Orientations Survey Data selected, or 
upload their own data by deselecting this option.

To upload your own dataset and accompanying *Meta.csv file, follow the steps shown in the GIF below.

<img src="images/CALMs.gif" style="border: 1px solid black; padding: 5px;" width="1000">

### Step 2: View Data

The labeling of the items in the original dataset (ISSP Research Group, 2017) was not intuitive for our illustrative example; hence, the original items were renamed as 
previously described and as depicted in Figure 2. 

<img src="images/Figure2.png" style="border: 1px solid black; padding: 5px;" width="1000">

**Figure 2.** *View Data Tab* 

### Step 3: Check Group Equivalency

CALMs uses the MatchIt package in R (Ho et al., 2011) for propensity score analyis including checking for group equivalency. The comparison groups for the demonstration with the 2015 Work Orientations Survey data are the USA and the UK. 
Hence, USA was selected as the **Grouping Variable**. 
All possible covariates were selected as **Covariates to Check**.

<img src="images/Figure3.png" style="border: 1px solid black; padding: 5px;" width="1000">

**Figure 3.** *Check Group Equivalency Tab* 

The output in Figure 3 shows that there are statistically (*p* < .05) and practically significant (Cramer’s V > .10) 
differences in employment type and degree by country. Specifically, employment type (SelfEmp) was found to be statistically significant while organization type 
(PrivateOrg) was found to be both statistically and practically significant.

### Step 4: Propensity Score Analysis Setup 

CALMs offers users the flexibility to use either a default call to MatchIt or to define a custom call. 
A link to the matchIt documentation is included within the application.

To customize the call, deselect **Use Default call to matchit** and edit the arugments following *data=dpsm* in the provided code box.

Two propensity score matching (PSM) methods, nearest neighbor and genetic matching, are the most common. 

- Nearest neighbor matching requires the input of all demographic variables and 
has been recommended as the most straightforward PSM method (Caliendo & Kopeinig, 2008; Keiffer & Lane, 2016). Although nearest neighbor is computationally 
effective with large datasets, the method pairs each treated unit with its nearest matching control without considering fully optimizing matches. This may lead 
to covariates not being optimally balanced with less equivalent groups, as compared to more stringent or robust matching methods. 

- Genetic matching is recommended when PSM output is required to have highly equivalent groups as it effectively achieves good matching balance even with highly 
complex data (Randolph et al., 2014). Genetic matching requires the input of all demographic variables (e.g., gender, age group, race/ethnicity, and educational 
level) into an algorithm that results in statistically (e.g., *p* ≤ .05) and practically (e.g., Cramer’s V ≥ .10) significant differences.

By default, CALMs uses the nearest neighbor method. 

<img src="images/Figure4.png" style="border: 1px solid black; padding: 5px;" width="1000">

**Figure 4.** *Propensity Score Analysis Setup Tab* 

### Step 5: Propensity Score Analysis

Figure 5 presents the result of the propensity score analysis using the default call previously described.

<img src="images/Figure5.png" style="border: 1px solid black; padding: 5px;" width="1000">

**Figure 5.** *Propensity Score Analysis Results Tab* 

The nearest neighbor method yielded two equivalent groups with 769 responses in each country. We observed that there were statistically significant 
differences in gender (Male) by country and elected to use the results of the nearest neighbor method since there was not a practically 
significant difference by country (all Cramer’s V < .10).

### Step 6: Measuremenent Invariance Tests

When conducting measurement invariance tests, the application defaults to using the matched dataset. 

To change this, users can deselect **Use matched data for invariance tests**. 

Users can also select the **Grouping Variable** and **Items to Analyze**. By default, the application
include all items identified in the `*`Meta.csv file as type *item*. 

Measurement invariance tests include configural, metric, and scalar. Omnibus and
scale-level tests are provided for both metric and scale invariance tests. Commonly recommended fit indices criteria include: (a) comparative fit index (CFI) ≥ .95; 
(b) standardized root-mean-square residuals (SRMR) ≤ .05; and (c) 
root-mean-squared-error of approximation (RMSEA) .05 to .08 (Kline, 2016; Schumacker & Lomax, 2016). 

Statistically significant model 
noninvariance is determined based on the p-value of the χ² difference test at *p* ≤ .05 (Cheung & Rensvold, 1999; van de Schoot et al., 2012). 
Guidelines have been provided to evaluate the ΔCFI for practical model (non)invariance, namely: (a) practical model invariance for ΔCFI ≥ -.01; 
(b) potential practical model noninvariance for ΔCFI between -.01 and -.02; and (c) practical model noninvariance for ΔCFI ≤ -.02 (Cheung & Rensvold, 2002). 

<img src="images/Figure6.png" style="border: 1px solid black; padding: 5px;" width="1000">

**Figure 6.** *Measurement Invariance Tab* 

The results of measurement invariance tests (see Figure 6) indicated that the configural model showed good fit. This model indicated good fit with a SRMR = .031 and 
CFI = .956. The metric model was compared to the configural model and met criteria for both statistical and practical 
invariance (Δχ²[4] = 8.484, *p* = .075; ΔCFI = -.004).
 However, the data did not reach the 
thresholds for scalar invariance (Δχ²[4] = 55.772, p < .001; ΔCFI = -.042). Both the JC (Δχ²[2] = 24.996, p < .001;  = -.019) and 
WE (Δχ²[2] = 30.796, p < .001; ΔCFI = -.023) scales demonstrated evidence of scalar non-invariance.

### Step 7: Metric Invariance Tests

In our illustrative example, it was not necessary to conduct follow-up tests for metric invariance as neither the omnibus test 
nor the scale-level tests for JC and WE indicated evidence of metric non-invariance. 

However, for demonstration purposes, we conducted metric invariance tests specifically on the JC scale.

Note that the application uses the p-value of the χ² difference test when determining invariant subsets of items (Cheung & Rensvold, 1999).
The default significance level (alpha) is set to .05, but users may adjust this threshold as needed. In this example, we set the alpha to .01 (see Figure 7). 

<img src="images/Figure7.png" style="border: 1px solid black; padding: 5px;" width="1000">

**Figure 7.** *Metric Invariance Tab* 

The factor ratio test (see Figure 7) confirmed that all JC items were metric invariant. Similarly, all WE items were metric invariant (tests not shown).

### Step 8: Scalar Invariance Tests

Because full scalar invariance was not demonstrated, we conducted partial MI testing on each scale. Had we determined that the factor loadings were 
non-invariant at the metric invariance assessment, we could have allowed a set of loadings to be freely estimated to allow for a partial scalar 
invariance assessment. 

<img src="images/Figure8.png" style="border: 1px solid black; padding: 5px;" width="1000">

**Figure 8.** *Scalar Invariance Tab* 

The factor ratio test (see Figure 8) identified JC2 and JC3 as a invariant subset of JC items (p > .01). Similarly,
WE1 and WE2 were identified (tests not shown) as a invariant subset of WE items (p > .01). 

Based on the results of the scalar invariance assessment, the intercepts for WE3 and JC1 
should be freely estimated to account for the partial scalar invariance.

### Step 9: Structural Invariance Tests

Building on the results of the scalar invariance testing, we allowed the intercepts for WE3 and JC1 to be freely estimated. Structural invariance is given 
when the comparison between an unconstrained and a constrained structural model yields a non-significant χ² difference (*p* > .05) and a non-significant CFI difference 
(Cheung & Rensvold, 1999; Cheung & Rensvold, 2002; Kline, 2016; Schumacker & Lomax, 2016). 

<img src="images/Figure9.png" style="border: 1px solid black; padding: 5px;" width="1000">

**Figure 9.** *Structural Invariance Tab* 

 The results indicate that the set of scales met the criteria for structural invariance. Although the structural invariance model was statistically significantly 
different from the scalar model (Δχ²[2] = 6.374, *p* = .041), the difference was not practically significant (ΔCFI = -.004; see Figure 9).
However, considering only JC, a statistically significant latent mean difference was observed (-.077, *p* = .013). Given that the 
latent mean for the USA was constrained to zero, the negative estimate indicates that the latent mean for the UK is lower in JC. There was no significant 
latent mean difference for WE across the two countries (-.047, *p* = .326). 


## References

Caliendo, M., & Kopeinig, S. (2008). Some practical guidance for the implementation of propensity score matching. *Journal of Economic Surveys, 22*(1), 31–72. https://doi.org/10.1111/j.1467-6419.2007.00527.x

Cheung, G. W., & Lau, R. S. (2012). A direct comparison approach for testing measurement invariance. *Organizational Research Methods, 15*(2), 167–198. https://doi.org/10.1177/1094428111421987

Cheung, G. W., & Rensvold, R. B. (1999). Testing factorial invariance across groups: A reconceptualization and proposed new method. *Journal of Management, 25*(1), 1–27. https://doi.org/10.1177/014920639902500101

Cheung, G. W., & Rensvold, R. B. (2002). Evaluating goodness-of-fit indexes for testing measurement invariance. *Structural Equation Modeling, 9*(2), 233–255. https://doi.org/10.1207/S15328007SEM0902_5

Ho, D., Imai, K., King, G., & Stuart, E. (2011). MatchIt: Nonparametric preprocessing for parametric causal inference. *Journal of Statistical Software, 42*(8), 1–28. https://doi.org/10.18637/jss.v042.i08

ISSP Research Group (2017). *International social survey programme: Work orientations IV – ISSP 2015*. GESIS data archive, Cologne. ZA6770 data file version 2.1.0, https://doi.org/10.4232/1.12848

Keiffer, G. L., & Lane, F. C. (2016). Propensity score analysis: An alternative statistical approach for HRD researchers. *European Journal of Training and Development, 40*(8/9), 660–675. https://doi.org/10.1108/EJTD-06-2015-0046

Kline, R. B. (2016). *Principles and practice of structural equation modeling* (4th ed.). New York: The Guilford Press.

Randolph, J. J., Falbe, K., Manuel, A., & Balloun, J. (2014). A step-by-step guide to propensity score matching in R. *Practical Assessment, Research & Evaluation, 19*, 1–6. https://doi.org/10.7275/n3pv-tx27

Schumacker, R. E., & Lomax, R. G. (2016). *A beginner’s guide to structural equation modeling* (4th ed.). New York: Routledge.

van de Schoot, R., Lugtig, P., & Hox, J. (2012). A checklist for testing measurement invariance. *European Journal of Developmental Psychology, 9*(4), 486–492. https://doi.org/10.1080/17405629.2012.686740
